#include <bits/stdc++.h>

using namespace std;

int main()
{
    int i, j, N, Q, e, l, r;
    cin>>N;
    int A[N];
    for (i=0;i<N;i++)
        cin>>A[i];
    cin>>Q;
    string ANS[Q];
    for (i=0;i<Q;i++)
    {
        cin>>l>>r;
        e=0;
        for (j=l;j<r;j++)
        {
            if (A[j-1]>A[j])
            {
                if (e==0)
                    e=1;
                else if (e==1)
                {
                    e=2;
                    j=N;
                }
                else if (A[j-2]>A[j])
                {
                    if (j!=l)
                    {
                        e=2;
                        j=N;
                    }
                }
            }
        }
        if (e==2)
            ANS[i]="NE";
        else
            ANS[i]="DA";

    }
    for (i=0;i<Q;i++)
    {
        cout<<ANS[i];
        if (i+1<Q)
            cout<<endl;
    }
    return 0;
}